<template>
  <div :class="{'hidden':hidden}" class="pagination-container">
    <el-pagination
      :background="background"
      :current-page.sync="currentPage"
      :page-size.sync="pageSize"
      :layout="layout"
      :page-sizes="pageSizes"
      :pager-count="pagerCount"
      :total="total"
      v-bind="$attrs"
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
    >
  </el-pagination>
  <!-- 自定义跳页区域 -->
  <!-- <template #sizes>
    <span class="page_size_text">每页 {{ pageSize }} 条</span>
  </template> -->
  </div>
</template>

<script>
import { scrollTo } from '@/utils/scroll-to'

export default {
  name: 'Pagination',
  props: {
    total: {
      required: true,
      type: Number
    },
    page: {
      type: Number,
      default: 1
    },
    limit: {
      type: Number,
      default: 20
    },
    pageSizes: {
      type: Array,
      default() {
        return [10, 20, 30, 50]
      }
    },
    // 移动端页码按钮的数量端默认值5
    pagerCount: {
      type: Number,
      default: document.body.clientWidth < 992 ? 5 : 7
    },
    layout: {
      type: String,
      default: 'total, sizes , prev, pager, next, jumper'
      // default: 'prev, pager, next, jumper'
    },
    background: {
      type: Boolean,
      default: true
    },
    autoScroll: {
      type: Boolean,
      default: true
    },
    hidden: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
    }
  },
  computed: {
    currentPage: {
      get() {
        return this.page
      },
      set(val) {
        this.$emit('update:page', val)
      }
    },
    pageSize: {
      get() {
        return this.limit
      },
      set(val) {
        this.$emit('update:limit', val)
      }
    }
  },
  // watch: {
  //   pageSize(newVal) {
  //     const sizesEl = document.querySelector('.el-pagination .el-pagination__sizes');
  //     if (sizesEl) {
  //       sizesEl.setAttribute('data-size', newVal);
  //     }
  //   }
  // },
  // mounted() {
  //   const sizesEl = document.querySelector('.el-pagination .el-pagination__sizes');
  //   if (sizesEl) {
  //     sizesEl.setAttribute('data-size', this.pageSize);
  //   }
  // },
  methods: {
    handleSizeChange(val) {
      if (this.currentPage * val > this.total) {
        this.currentPage = 1
      }
      this.$emit('pagination', { page: this.currentPage, limit: val })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    },
    handleCurrentChange(val) {
      this.$emit('pagination', { page: val, limit: this.pageSize })
      if (this.autoScroll) {
        scrollTo(0, 800)
      }
    }
  }
}
</script>

<style scoped>
.pagination-container {
  background: transparent;
  
}
.pagination-container.hidden {
  display: none;
}
::v-deep .el-pagination {
  .el-pagination__total,.el-pagination__jump{
    color: #FFFFFF;
  }
  .btn-prev,
  .btn-next,
  .el-pager li{
    background-color: transparent;
    border: 1px solid #77d7ff;
    color: #FFFFFF;
    i{
      color: #77d7ff;
    }
  }
  .el-pager li:not(.disabled):hover{
    color: #77d7ff;
  }
  .el-pager li:not(.disabled).active{
    background-color: #77d7ff;
    color: #000;
  }
  .el-pagination__jump{
    .el-input__inner{
      background-color: transparent;
      border: 1px solid #77d7ff;
      color: #FFFFFF;
    }
  }


  .el-pagination__sizes .el-select{
    display: none;
  }
  .el-pagination__sizes::after {
      /* content: "每页 " attr(data-size) " 条"; */
      content: "10  条/页";
      display: inline-block;
      margin-left: 10px;
      color: #FFFFFF;
    }
}
</style>
